<?php 
/*** 
Template Name: Portfolio 
***/ 
get_header(); ?>

<div class="container">

    <?php
    while ( have_posts() ) :
    the_post();

    the_content();

    endwhile; // End of the loop.
    ?>

</div>

<section id="portfolio">
    <div class="container_filters_portfolio">
        <div class="container">
            <ul id="filter_portfolio" class="controls">
                <li><button type="button" data-filter="all">ALL</button><i class="count"></i></li>
                <?php

                $taxonomy = 'portfolio_category';
                $terms = get_terms($taxonomy); // Get all terms of a taxonomy

                if ( $terms && !is_wp_error( $terms ) ) :
                ?>
                <?php foreach ( $terms as $term ) { ?>
                <li idx="<?php echo $term->slug; ?>"><button type="button" data-filter=".<?php echo $term->slug; ?>"><?php echo $term->name; ?></button><i class="count"></i></li>
                <?php } ?>

                <?php endif;?>
            </ul>
        </div>
    </div>

    <div class="container">
        <ul class="container_portfolio">

            <?php 
            query_posts(array( 
                'post_type'      => 'portfolio_item',
                'posts_per_page' => '-1'
            ) );  
            ?>

            <?php while (have_posts()) : the_post(); ?>

            <?php 

            $terms = get_the_terms($post->ID,'portfolio_category');

            $categoria = '';
            foreach($terms as $term)
            {
                $categoria = $categoria." ".$term->slug;
            }
			
            ?>        

            <li class="mix <?php echo $categoria; ?>" style="background-image:url('<?php the_field('background_logo') ?>')">
                <a href="<?php the_permalink(); ?>"></a>
                <figure><img src="<?php the_field('white_logo') ?>"></figure>
            </li>

            <?php endwhile;?><?php wp_reset_query(); ?>       

        </ul>
    </div>
</section>

<script type="text/javascript" src="<?php echo get_template_directory_uri(); ?>/mixitup.min.js"></script>
<script>
    var containerEl = document.querySelector('.container_portfolio');

    var mixer = mixitup(containerEl);
    jQuery(document).ready(function(){
        jQuery('#filter_portfolio').click(function(){
            setTimeout(function(){ 
                jQuery(document).resize()
            }, 210);
        })
    })
	
	jQuery(document).ready(function()
	{
		jQuery.each(jQuery('[idx]'),function()
		{
			jQuery(this).find('.count').text(jQuery('.container_portfolio li.'+jQuery(this).attr('idx')).length)
		})
		
		jQuery('#filter_portfolio li:first-child i.count').text(jQuery('.container_portfolio li').length);
	})
	
</script>

<style>

	#filter_portfolio li i.count {
	position: absolute;
    font-size: 14px;
    top: -40px;
    left: 50%;
    transform: translateX(-50%);
    background: #fff;
    padding: 5px 20px;
    border-radius: 5px;
    color: #6fac2b;
    font-weight: 500;
		display:none;
	}
	
	#filter_portfolio li:hover i.count {
		display:block;
	}
	
	#filter_portfolio li {
		position:relative;
	}

</style>

<?php get_footer(); ?>